package pol;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

public class PotentialFieldTest {
    @Test
    public void testAddBlob() {
        final PotentialField pf = new PotentialField(4, 5);

        pf.addBlob(2, 3, 1, 1);

        final double v = pf.value(2, 3);
        assertEquals(1.0, v, 1e-10);

        final double[] dv = pf.dv(3, 4, 0, 0);
        assertTrue("dv[0] goes down gradient", dv[0] > 0);
        assertTrue("dv[1] goes down gradient", dv[1] > 0);
    }

    @Test
    public void testAddWalls() {

    }

    @Test
    public void testClear() {
        final PotentialField pf = new PotentialField(4, 5);

        pf.addBlob(2, 3, 1, 1);
        assertEquals(1.0, pf.value(2, 3), 1e-10);

        pf.clear();

        assertEquals(0, pf.value(2, 3), 1e-10);
    }

    @Test
    public void testDv() {
        final PotentialField pf = new PotentialField(4, 5);

        final double[] dv = pf.dv(2, 3, 50, 40);
        assertEquals(50.0, dv[0], 1e-10);
        assertEquals(40.0, dv[1], 1e-10);
    }

    @Test
    public void testGradient() {
        final PotentialField pf = new PotentialField(4, 5);

        final double[] g = pf.gradient(2, 3);
        assertEquals(0.0, g[0], 1e-10);
        assertEquals(0.0, g[1], 1e-10);
    }

    @Test
    public void testValue() {
        final PotentialField pf = new PotentialField(4, 5);

        assertEquals(0, pf.value(0, 0), 1e-10);
    }
}
